using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_RepositoryInformation
	/// </summary>
	public partial class T_RepositoryInformation
    {
        public T_RepositoryInformation()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_RepositoryId", "T_RepositoryInformation");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_RepositoryId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_RepositoryInformation");
            strSql.Append(" where F_RepositoryId=@F_RepositoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RepositoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_RepositoryId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_RepositoryInformation model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_RepositoryInformation(");
            strSql.Append("F_CategoryId,F_CustomerId,F_CustomerName,F_ManId,F_ManName,F_Title,F_Content,F_Description,F_Comments,F_Url,F_KeyWords,F_Expand1,F_Expand2,F_IntExpand1,F_CreateOn,F_CreateBy,F_CreateName,F_ModifyOn,F_ModifyBy,F_ModifyName,F_DeleteFlag)");
            strSql.Append(" values (");
            strSql.Append("@F_CategoryId,@F_CustomerId,@F_CustomerName,@F_ManId,@F_ManName,@F_Title,@F_Content,@F_Description,@F_Comments,@F_Url,@F_KeyWords,@F_Expand1,@F_Expand2,@F_IntExpand1,@F_CreateOn,@F_CreateBy,@F_CreateName,@F_ModifyOn,@F_ModifyBy,@F_ModifyName,@F_DeleteFlag)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_CustomerId", SqlDbType.Int,4),
                    new SqlParameter("@F_CustomerName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_ManId", SqlDbType.Int,4),
                    new SqlParameter("@F_ManName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_Description", SqlDbType.NText),
                    new SqlParameter("@F_Comments", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Url", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_KeyWords", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Expand1", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Expand2", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_IntExpand1", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateName", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_ModifyOn", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyName", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2)};
            parameters[0].Value = model.F_CategoryId;
            parameters[1].Value = model.F_CustomerId;
            parameters[2].Value = model.F_CustomerName;
            parameters[3].Value = model.F_ManId;
            parameters[4].Value = model.F_ManName;
            parameters[5].Value = model.F_Title;
            parameters[6].Value = model.F_Content;
            parameters[7].Value = model.F_Description;
            parameters[8].Value = model.F_Comments;
            parameters[9].Value = model.F_Url;
            parameters[10].Value = model.F_KeyWords;
            parameters[11].Value = model.F_Expand1;
            parameters[12].Value = model.F_Expand2;
            parameters[13].Value = model.F_IntExpand1;
            parameters[14].Value = model.F_CreateOn;
            parameters[15].Value = model.F_CreateBy;
            parameters[16].Value = model.F_CreateName;
            parameters[17].Value = model.F_ModifyOn;
            parameters[18].Value = model.F_ModifyBy;
            parameters[19].Value = model.F_ModifyName;
            parameters[20].Value = model.F_DeleteFlag;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_RepositoryInformation model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_RepositoryInformation set ");
            strSql.Append("F_CategoryId=@F_CategoryId,");
            strSql.Append("F_CustomerId=@F_CustomerId,");
            strSql.Append("F_CustomerName=@F_CustomerName,");
            strSql.Append("F_ManId=@F_ManId,");
            strSql.Append("F_ManName=@F_ManName,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_Description=@F_Description,");
            strSql.Append("F_Comments=@F_Comments,");
            strSql.Append("F_Url=@F_Url,");
            strSql.Append("F_KeyWords=@F_KeyWords,");
            strSql.Append("F_Expand1=@F_Expand1,");
            strSql.Append("F_Expand2=@F_Expand2,");
            strSql.Append("F_IntExpand1=@F_IntExpand1,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_CreateName=@F_CreateName,");
            strSql.Append("F_ModifyOn=@F_ModifyOn,");
            strSql.Append("F_ModifyBy=@F_ModifyBy,");
            strSql.Append("F_ModifyName=@F_ModifyName,");
            strSql.Append("F_DeleteFlag=@F_DeleteFlag");
            strSql.Append(" where F_RepositoryId=@F_RepositoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_CustomerId", SqlDbType.Int,4),
                    new SqlParameter("@F_CustomerName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_ManId", SqlDbType.Int,4),
                    new SqlParameter("@F_ManName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_Description", SqlDbType.NText),
                    new SqlParameter("@F_Comments", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Url", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_KeyWords", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Expand1", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Expand2", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_IntExpand1", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateName", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_ModifyOn", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyName", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_RepositoryId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CategoryId;
            parameters[1].Value = model.F_CustomerId;
            parameters[2].Value = model.F_CustomerName;
            parameters[3].Value = model.F_ManId;
            parameters[4].Value = model.F_ManName;
            parameters[5].Value = model.F_Title;
            parameters[6].Value = model.F_Content;
            parameters[7].Value = model.F_Description;
            parameters[8].Value = model.F_Comments;
            parameters[9].Value = model.F_Url;
            parameters[10].Value = model.F_KeyWords;
            parameters[11].Value = model.F_Expand1;
            parameters[12].Value = model.F_Expand2;
            parameters[13].Value = model.F_IntExpand1;
            parameters[14].Value = model.F_CreateOn;
            parameters[15].Value = model.F_CreateBy;
            parameters[16].Value = model.F_CreateName;
            parameters[17].Value = model.F_ModifyOn;
            parameters[18].Value = model.F_ModifyBy;
            parameters[19].Value = model.F_ModifyName;
            parameters[20].Value = model.F_DeleteFlag;
            parameters[21].Value = model.F_RepositoryId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_RepositoryId)
        {

            StringBuilder strSql = new StringBuilder();
            //strSql.Append("delete from T_RepositoryInformation ");
            strSql.Append("update T_RepositoryInformation set F_DeleteFlag=1");
            strSql.Append(" where F_RepositoryId=@F_RepositoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RepositoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_RepositoryId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_RepositoryIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            //strSql.Append("delete from T_RepositoryInformation ");
            strSql.Append("update T_RepositoryInformation set F_DeleteFlag=1");
            strSql.Append(" where F_RepositoryId in (" + F_RepositoryIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_RepositoryInformation GetModel(int F_RepositoryId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_RepositoryId,F_CategoryId,F_CustomerId,F_CustomerName,F_ManId,F_ManName,F_Title,F_Content,F_Description,F_Comments,F_Url,F_KeyWords,F_Expand1,F_Expand2,F_IntExpand1,F_CreateOn,F_CreateBy,F_CreateName,F_ModifyOn,F_ModifyBy,F_ModifyName,F_DeleteFlag from T_RepositoryInformation ");
            strSql.Append(" where F_RepositoryId=@F_RepositoryId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RepositoryId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_RepositoryId;

            Model.T_RepositoryInformation model = new Model.T_RepositoryInformation();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_RepositoryInformation DataRowToModel(DataRow row)
        {
            Model.T_RepositoryInformation model = new Model.T_RepositoryInformation();
            if (row != null)
            {
                if (row["F_RepositoryId"] != null && row["F_RepositoryId"].ToString() != "")
                {
                    model.F_RepositoryId = int.Parse(row["F_RepositoryId"].ToString());
                }
                if (row["F_CategoryId"] != null && row["F_CategoryId"].ToString() != "")
                {
                    model.F_CategoryId = int.Parse(row["F_CategoryId"].ToString());
                }
                if (row["F_CustomerId"] != null && row["F_CustomerId"].ToString() != "")
                {
                    model.F_CustomerId = int.Parse(row["F_CustomerId"].ToString());
                }
                if (row["F_CustomerName"] != null)
                {
                    model.F_CustomerName = row["F_CustomerName"].ToString();
                }
                if (row["F_ManId"] != null && row["F_ManId"].ToString() != "")
                {
                    model.F_ManId = int.Parse(row["F_ManId"].ToString());
                }
                if (row["F_ManName"] != null)
                {
                    model.F_ManName = row["F_ManName"].ToString();
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_Description"] != null)
                {
                    model.F_Description = row["F_Description"].ToString();
                }
                if (row["F_Comments"] != null)
                {
                    model.F_Comments = row["F_Comments"].ToString();
                }
                if (row["F_Url"] != null)
                {
                    model.F_Url = row["F_Url"].ToString();
                }
                if (row["F_KeyWords"] != null)
                {
                    model.F_KeyWords = row["F_KeyWords"].ToString();
                }
                if (row["F_Expand1"] != null)
                {
                    model.F_Expand1 = row["F_Expand1"].ToString();
                }
                if (row["F_Expand2"] != null)
                {
                    model.F_Expand2 = row["F_Expand2"].ToString();
                }
                if (row["F_IntExpand1"] != null && row["F_IntExpand1"].ToString() != "")
                {
                    model.F_IntExpand1 = int.Parse(row["F_IntExpand1"].ToString());
                }
                if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                }
                if (row["F_CreateBy"] != null && row["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(row["F_CreateBy"].ToString());
                }
                if (row["F_CreateName"] != null)
                {
                    model.F_CreateName = row["F_CreateName"].ToString();
                }
                if (row["F_ModifyOn"] != null && row["F_ModifyOn"].ToString() != "")
                {
                    model.F_ModifyOn = DateTime.Parse(row["F_ModifyOn"].ToString());
                }
                if (row["F_ModifyBy"] != null && row["F_ModifyBy"].ToString() != "")
                {
                    model.F_ModifyBy = int.Parse(row["F_ModifyBy"].ToString());
                }
                if (row["F_ModifyName"] != null)
                {
                    model.F_ModifyName = row["F_ModifyName"].ToString();
                }
                if (row["F_DeleteFlag"] != null && row["F_DeleteFlag"].ToString() != "")
                {
                    model.F_DeleteFlag = int.Parse(row["F_DeleteFlag"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_RepositoryId,F_CategoryId,F_CustomerId,F_CustomerName,F_ManId,F_ManName,F_Title,F_Content,F_Description,F_Comments,F_Url,F_KeyWords,F_Expand1,F_Expand2,F_IntExpand1,F_CreateOn,F_CreateBy,F_CreateName,F_ModifyOn,F_ModifyBy,F_ModifyName,F_DeleteFlag ");
            strSql.Append(" FROM T_RepositoryInformation ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_RepositoryId,F_CategoryId,F_CustomerId,F_CustomerName,F_ManId,F_ManName,F_Title,F_Content,F_Description,F_Comments,F_Url,F_KeyWords,F_Expand1,F_Expand2,F_IntExpand1,F_CreateOn,F_CreateBy,F_CreateName,F_ModifyOn,F_ModifyBy,F_ModifyName,F_DeleteFlag ");
            strSql.Append(" FROM T_RepositoryInformation ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_RepositoryInformation ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_RepositoryId desc");
            }
            strSql.Append(")AS Row, T.*  from T_RepositoryInformation T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
